#!/bin/sh

# for this to work, it must be in /home/ptahusr/public_html
#     that directory must be 755
#     the bin must be 755 and NOT setuid
#
#/etc/httpd/conf/httpd.conf must have the following lines added:
#     <Directory "/home/ptahusr">
#         AllowOverride None
#         Order allow,deny
#         Allow from all
#         Options ExecCGI
#         AddHandler cgi-script .cgi
#     </Directory>
#     <IfModule mod_userdir.c>
#         UserDir disabled
#         UserDir enabled ptahusr
#         UserDir /home/*
#     </IfModule>
#
#it must be invoked as http://server/~ptahusr/public_html/listptah.cgi
#
#/home/ptahusr/pvmhosts must have a list of the IP addresses you want to check
#
#ptahusr must exist on server and on all hosts, all with same password
#
#and the server must be in the /home/ptahusr/.rhosts file on all of the PCs

d="/tmp"
master=192.168.1.254

echo '<html><body><h1>Cluster PCs currently running ptah:</h1><ol>' > $d/scanptah.out
echo ' ' >> $d/scanptah.out
for h in `cat /home/ptahusr/pvmhosts` ; do
    pso=$(rsh $h ps ux 2>/dev/null | grep -e "[RS] .* [0-9]*:[0-9]* /home/ptah")
    if [ -n "$pso" ]; then
	pso=$(echo $pso | sed -e 's/ ptahusr.*//')
	vm=$(echo $pso | sed -e "s/ptahusr [0-9]* [0-9]*.[0-9] [0-9]*.[0-9]//")
	t=$(echo $vm | sed -e "s/^.* [RS] * //" | sed -e "s% % / %" | sed -e "s%/home.*$%%")
	vm=$(echo $vm | sed -e "s/?.*$//" | sed -e 's%pts/.*$%%' | sed -e "s% % / %")
	echo "<li>host = $h vm / rsz = $vm start / cpu time = $t</li>" >> $d/scanptah.out
    fi
done
echo '</ol><p><h1>Last 100 lines of master stderr</h1><p>' >> $d/scanptah.out
rsh $master tail --lines 100 /home/ptahusr/ptah.err | sed -e 's/$/<br>/' >> $d/scanptah.out
echo '</body></html>' >> $d/scanptah.out
echo Content-type: text/html
echo
cat $d/scanptah.out
echo
