//
// PTAH - Parallel Tensor Analysis Hybrid   Copyright (C) 2002 Kenneth R. Koehler 
//
// e-mail address - kenneth.koehler@uc.edu
//
// This program is free software; you can redistribute it and/or modify it under the terms of the
// GNU General Public License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
// without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
// PURPOSE. See the GNU General Public License for more details. 
//
// You should have received a copy of the GNU General Public License along with this program; if
// not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// main.cc

#include <ptah.h>
#include <element.h>
#include <hash.h>
#include <ntuple.h>
#include <main.h>
#include <metric.h>

ntuple* ast1;
ntuple* ast2;
ntuple* ast3;
ntuple* ast4;
ntuple* ast5;
ntuple* rlist[5];
sum* test;
int dualmat[10] = {0,0,0,0,0,0,0,0,0,0};

bool trueparm[2] = {true, true}; 
bool falseparm[2] = {false, false}; 
bool antiparm[2] = {true, false}; 

int main (int argcount, char **args) {

//    parallel = false;         // initial stuff does not require parallel
  parallel = true;

  time_stamp();

  g = new ntuple (2, falseparm, falseparm, trueparm, falseparm);
  g->tensor_build (gcnt, gind, gnumtrm, gnumfct, gpwr, gco);
  g->metric = true;

  g_inverse = new ntuple (2, trueparm, falseparm, trueparm, falseparm);
  g_inverse->tensor_build (gicnt, giind, ginumtrm, ginumfct, gipwr, gico);
  g_inverse->metric = true;

  inverse_sqrt_det_g = new sum;
  inverse_sqrt_det_g->sum_build (1, dnumfct, dpwr, dco);

  ast1 = new ntuple (2, falseparm, antiparm, falseparm, falseparm);
  ast1->tensor_build (ast1cnt, ast1ind, ast1numtrm, ast1numfct, ast1pwr, ast1co);

  ast2 = new ntuple (2, falseparm, antiparm, falseparm, falseparm);
  ast2->tensor_build (ast2cnt, ast2ind, ast2numtrm, ast2numfct, ast2pwr, ast2co);

  ast3 = new ntuple (2, falseparm, antiparm, falseparm, falseparm);
  ast3->tensor_build (ast3cnt, ast3ind, ast3numtrm, ast3numfct, ast3pwr, ast3co);

  ast4 = new ntuple (2, falseparm, antiparm, falseparm, falseparm);
  ast4->tensor_build (ast4cnt, ast4ind, ast4numtrm, ast4numfct, ast4pwr, ast4co);

  ast5 = new ntuple (2, falseparm, antiparm, falseparm, falseparm);
  ast5->tensor_build (ast5cnt, ast5ind, ast5numtrm, ast5numfct, ast5pwr, ast5co);

  if (argcount >= 2) {
    g->display ("gp");
    g_inverse->display ("ginv");
    inverse_sqrt_det_g->display ("isrdmg");
    ast1->display ("ast1");
    ast2->display ("ast2");
    ast3->display ("ast3");
    ast4->display ("ast4");
    ast5->display ("ast5");}

  rlist[0] = ast1;
  rlist[1] = ast2;
  rlist[2] = ast3;
  rlist[3] = ast4;
  rlist[4] = ast5;
  test = ast1->dual_invariant (5, (ntuple**) rlist, dualmat, false);
  test->display_add ("test");

  time_stamp ("Test completed");

  entry_stats ();
  return 0; }
