//
// PTAH - Parallel Tensor Analysis Hybrid   Copyright (C) 2002 Kenneth R. Koehler 
//
// e-mail address - kenneth.koehler@uc.edu
//
// This program is free software; you can redistribute it and/or modify it under the terms of the
// GNU General Public License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
// without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
// PURPOSE. See the GNU General Public License for more details. 
//
// You should have received a copy of the GNU General Public License along with this program; if
// not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// main.h

ntuple* g;
ntuple* g_inverse;
sum* inverse_sqrt_det_g;
int number_of_epsilons, epsilon_length;
int* which_epsilon;

connection* christoffel;
curvature* riemann;
ntuple* riemann_all_low;
ntuple* ricci;
ntuple* traceless_ricci;
ntuple* einstein_curv;
ntuple* g_curv;
ntuple* weyl;
sum* scacurv;

sum* dilaton;
ntuple* dphi;
ntuple* fs;
ntuple* fsuuuu;
ntuple* viel;
ntuple* vielinv;
ntuple* omega;
ntuple* susyparm;
ntuple* dilatino;
ntuple* gravitino;
ntuple* gaugefield;
ntuple* graviton;

bool parallel = false;
bool parent = false;

long sec = -1;
long micro;
long t0sec = -1;
long t0micro;

#ifdef tracentry
long trace_ff = 0;
long trace_tf = 0;
long trace_ei = 0;
long trace_e = 0;
long trace_ke = 0;
long trace_ne = 0;
long trace_ie = 0;
long trace_re = 0;
long trace_td = 0;
long trace_t = 0;
long trace_kt = 0;
long trace_nt = 0;
long trace_it = 0;
long trace_int = 0;
long trace_kint = 0;
long trace_nint = 0;
long trace_iit = 0;
long trace_rinl = 0;
long trace_hc = 0;
long trace_sh = 0;
long trace_iah = 0;
long trace_rfl = 0;
long trace_sit = 0;
long trace_srt = 0;
long trace_ft = 0;
long trace_f = 0;
long trace_sa = 0;
long trace_smu = 0;
long trace_sumu = 0;
long trace_nsmu = 0;
long trace_nms = 0;
long trace_flr = 0;
long trace_ntr = 0;
long trace_szq = 0;
long trace_fit = 0;
long trace_irt = 0;
long trace_ia = 0;
long trace_rfi = 0;
long trace_co = 0;
long trace_co2 = 0;
long trace_kco = 0;
long trace_nco = 0;
long trace_ic = 0;
long trace_rc = 0;
long trace_fc = 0;
long trace_fi = 0;
long trace_csu = 0;
long trace_nst = 0;
long trace_nss = 0;
long trace_na = 0;
long trace_n1 = 0;
long trace_n = 0;
long trace_nal = 0;
long trace_kn = 0;
long trace_ni = 0;
long trace_mfil = 0;
long trace_msl = 0;
long trace_ncn = 0;
long trace_nci = 0;
long trace_nz = 0;
long trace_nc = 0;
long trace_nan = 0;
long trace_fil = 0;
long trace_ncl = 0;
long trace_nr = 0;
long trace_nl = 0;
long trace_ncd = 0;
long trace_nsc = 0;
long trace_nnc = 0;
long trace_nd = 0;
long trace_ns = 0;
long trace_nsi = 0;
long trace_ndi = 0;
long trace_gb = 0;
long trace_ge = 0;
long trace_gin = 0;
long trace_gs = 0;
long trace_gi = 0;
long trace_gam = 0;
long trace_eb = 0;
long trace_ee = 0;
long trace_epi = 0;
long trace_es = 0;
long trace_cc = 0;
long trace_ccu = 0;
long trace_ri = 0;
long trace_we = 0;
long trace_s = 0;
long trace_ks = 0;
long trace_sz = 0;
long trace_sm = 0;
long trace_sd = 0;
long trace_sog = 0;
long trace_stg = 0;
long trace_sfg = 0;
long trace_sex = 0;
long trace_iex = 0;
long trace_cs = 0;
long trace_id = 0;
long trace_ss = 0;
long trace_sn = 0;
long trace_i = 0;
long trace_ki = 0;
long trace_iz = 0;
long trace_im = 0;
long trace_is = 0;
long trace_cd = 0;
long trace_ps = 0;
long trace_pst = 0;
long trace_tin = 0;
long trace_ti = 0;
long trace_pi = 0;
long trace_ip = 0;
long trace_sp = 0;
long trace_si = 0;
long trace_spa = 0;
long trace_as = 0;
long trace_ci = 0;
long trace_spar = 0;
long trace_sps = 0;
long trace_cspar = 0;
long trace_tspar = 0;
long trace_com = 0;
long trace_npn = 0;
long trace_nps = 0;
long trace_nfp = 0;
long trace_npd = 0;
#endif

#ifdef keepstats
#ifdef debug
int keep_head_count[large_hash_size];
#endif
#endif
