(* PTAH - Parallel Tensor Analysis Hybrid   Copyright (C) 2002 Kenneth R. Koehler 

 e-mail address - kenneth.koehler@uc.edu

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE. See the GNU General Public License for more details. 

 You should have received a copy of the GNU General Public License along with this 
 program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 Cambridge, MA 02139, USA. 
 
 ccif.nb
time coordinate must be last
gp, ginvp, and irmdgp (inverse root minus det g) must be specified (parameterized versions) *)
Off[General::spell, General::spell1, Syntax::com];
<< ~/projects/ptah/mathematica/sugra.m
findenom[xx_Rational] := Block[{nn, ff}, (nn = Denominator[xx];
			ff = FactorInteger[nn];
			Do[AppendTo[ints, ff[[ii, 1]]];, {ii, Length[ff]}];
			ints = Union[ints];)];
findenom[xx_Times] := Do[findenom[xx[[ii]]], {ii, Length[xx]}];
findenom[xx_Plus] := Do[findenom[xx[[ii]]], {ii, Length[xx]}];
findenom[xx_List] := Block[{nn}, (nn = Flatten[xx];
				Do[findenom[nn[[ii]]], {ii, Length[nn]}])];

sub[xx_] := If[xx == 1, Length[coords], xx - 1];

countfactors[xx_Times] := Sum[If[Head[xx[[ii]]] =!= Integer,
			countfactors[xx[[ii]]], 0], {ii, Length[xx]}];
countfactors[xx_Rational] := Length[FactorInteger[Denominator[xx]]];
countfactors[xx_] := 1;

coeff[xx_] := Block[{}, (If[Head[xx] === Complex, Return[xx/I],];
        If[Head[xx] === Rational, Return[Sign[xx]Abs[Numerator[xx]]],];
        If[NumericQ[xx], Return[xx],];
        If[Head[xx] =!= Times, Return[1],];
        If[Head[xx[[1]]] === Rational, 
          Return[Sign[xx[[1]]]Abs[Numerator[xx[[1]]]]],];
        If[NumericQ[xx[[1]]], Return[xx[[1]]], Return[1], Return[1]];)];

whichvar[xx_Rational, bb_] := Block[{nn}, (
			nn = FactorInteger[Denominator[xx]];
			Do[(WriteString[mout, Position[var, nn[[ll, 1]]][[1, 1]] - 1, 
              ",", -nn[[ll, 2]]];
					If[bb || (ll < Length[nn]), WriteString[mout, ","],];), {ll, 
            Length[nn]}];)];
whichvar[xx_Power, 
      bb_] := (WriteString[mout, Position[var, xx[[1]]][[1, 1]] - 1, ",", 
        xx[[2]]];
		If[bb, WriteString[mout, ","],];);
whichvar[xx_Symbol, 
      bb_] := (WriteString[mout, Position[var, xx][[1, 1]] - 1, ",", 1];
		If[bb, WriteString[mout, ","],];);
whichvar[xx_Complex, 
      bb_] := (WriteString[mout, Position[var, I][[1, 1]] - 1, ",", 1];
		If[bb, WriteString[mout, ","],];);
whichvar[xx_, bb_] := (WriteString[mout, -1, ",", 0];
		If[bb, WriteString[mout, ","],];);

dopows[xx_Times, bb_] := Do[If[Head[xx[[kk]]] =!= Integer,
			whichvar[xx[[kk]], bb || (kk < Length[xx])],], {kk, Length[xx]}];
dopows[xx_, bb_] := whichvar[xx, bb];

exprout[xx_, ss_] := Block[{terms, numterms, factors, nn}, (
        nn = Length[xx];
        WriteString[mout, "int ", ss, "numtrm[", nn, "] = {"];
        terms = 0;
        Do[(numterms = If[Head[xx[[ii]]] === Plus, Length[xx[[ii]]], 1];
            WriteString[mout, numterms];
            terms = terms + numterms;
            If[ii < nn, WriteString[mout, ","],];), {ii, nn}];
        WriteString[mout, "};\n"];
        WriteString[mout, "int ", ss, "numfct[", terms, "] = {"];
        factors = If[sortvar[[1]] === 0, 0, fun + ans];
        (* Print["sortvar= ", sortvar]; *)
        
        Do[(If[Head[xx[[ii]]] === Plus,
                (Do[
                    If[jj != 
                        sortvar[[ii]], (WriteString[mout, 
                          countfactors[xx[[ii, jj]]]];
                        factors = factors + countfactors[xx[[ii, jj]]];
                        
                        If[(ii < nn) || (jj < 
                                Length[xx[[ii]]]) || (sortvar[[ii]] > 0),
                          WriteString[mout, ","],];),], {jj, 
                      Length[xx[[ii]]]}];
                  If[sortvar[[ii]] =!= 0, (WriteString[mout, 1];
                      If[ii < nn, WriteString[mout, ","],];),];),
                (WriteString[mout, countfactors[xx[[ii]]]];
                  factors = factors + countfactors[xx[[ii]]];
                  If[ii < nn, WriteString[mout, ","],];)];), {ii, nn}];
        WriteString[mout, "};\n"];
        WriteString[mout, "int ", ss, "pwr[", 2factors, "] = {"];
        Do[(If[Head[xx[[ii]]] === Plus,
              (Do[If[jj != sortvar[[ii]],
                    (dopows[
                        xx[[ii, 
                            jj]], (ii < nn) || (jj < 
                              Length[xx[[ii]]]) || (sortvar[[ii]] > 0)];
                      WriteString[mout, " "];
                      
                      If[(Length[xx[[ii]]] > 4) && (Mod[jj, 4] == 0) && (jj !=
                               Length[xx[[ii]]]),
                        WriteString[mout, "\n                   "],];),], {jj,
                     Length[xx[[ii]]]}];
                If[sortvar[[ii]] > 0, 
                  dopows[xx[[ii, sortvar[[ii]]]], ii < nn],];),
              dopows[xx[[ii]], (ii < nn)]];
            If[ii < nn, WriteString[mout, "\n               "],];), {ii, 
            nn}];
        WriteString[mout, "};\n"];
        WriteString[mout, "long long ", ss, "co[", terms, "] = {"];
        Do[(If[Head[xx[[ii]]] === Plus,
              (Do[If[jj != sortvar[[ii]], (
                      WriteString[mout, coeff[xx[[ii, jj]]]];
                      
                      If[(ii < nn) || (jj < 
                              Length[xx[[ii]]]) || (sortvar[[ii]] > 0),
                        WriteString[mout, ","],];),], {jj, 
                    Length[xx[[ii]]]}];
                
                If[sortvar[[ii]] =!= 
                    0, (WriteString[mout, coeff[xx[[ii, sortvar[[ii]]]]]];
                    If[ii < nn, WriteString[mout, ","],];),];),
              (WriteString[mout, coeff[xx[[ii]]]];
                If[(ii < nn), WriteString[mout, ","],];)];
            If[ii < nn, WriteString[mout, "\n              "],];), {ii, nn}];
        WriteString[mout, "};\n"];)];
indout[xx_List, ss_, nn_List] := Block[{tt, tn, rank}, (tt = Flatten[xx];
        rank = TensorRank[xx];
        tn = 0;
        Do[If[tt[[ii]] =!= 0, tn = tn + 1,], {ii, Length[tt]}];
        WriteString[mout, "#define ", ss, "cnt ", tn, "\n"];
        If[rank == 1, (WriteString[mout, "int ", ss, "ind[", tn, "] = {"];
            Do[If[xx[[ii]] =!= 0, (WriteString[mout,
                    If[nn[[1]] < 0, ii - 1, If[ii == nn[[1]], 0, ii]]];
                  If[(ii < Abs[nn[[1]]]), WriteString[mout, ","],];),], {ii, 
                Abs[nn[[1]]]}];),];
        If[rank == 2, (WriteString[mout, "int ", ss, "ind[", 2tn, "] = {"];
            Do[Do[If[xx[[ii, jj]] =!= 0, (WriteString[mout,
                      If[nn[[1]] < 0, ii - 1, If[ii == nn[[1]], 0, ii]], ",",
                      If[nn[[2]] < 0, jj - 1, If[jj == nn[[2]], 0, jj]]];
                    
                    If[(ii < Abs[nn[[1]]]) || (jj < Abs[nn[[2]]]), 
                      WriteString[mout, ","],];),],
                {jj, Abs[nn[[2]]]}], {ii, Abs[nn[[1]]]}];),];
        If[rank == 3, (WriteString[mout, "int ", ss, "ind[", 3tn, "] = {"];
            Do[Do[Do[If[xx[[ii, jj, kk]] =!= 0,
                    (WriteString[mout,
                        If[nn[[1]] < 0, ii - 1, If[ii == nn[[1]], 0, ii]], 
                        ",",
                        If[nn[[2]] < 0, jj - 1, If[jj == nn[[2]], 0, jj]], 
                        ",",
                        If[nn[[3]] < 0, kk - 1, If[kk == nn[[3]], 0, kk]]];
                      
                      If[(ii < Abs[nn[[1]]]) || (jj < Abs[nn[[2]]]) || (kk < 
                              Abs[nn[[3]]]), WriteString[mout, ","],];),],
                  {kk, Abs[nn[[3]]]}], {jj, Abs[nn[[2]]]}], {ii, 
                Abs[nn[[1]]]}];),];
        If[rank == 4, (WriteString[mout, "int ", ss, "ind[", 4tn, "] = {"];
            Do[Do[Do[Do[If[xx[[ii, jj, kk, ll]] =!= 0,
                      (WriteString[mout,
                          If[nn[[1]] < 0, ii - 1, If[ii == nn[[1]], 0, ii]], 
                          ",",
                          If[nn[[2]] < 0, jj - 1, If[jj == nn[[2]], 0, jj]], 
                          ",",
                          If[nn[[3]] < 0, kk - 1, If[kk == nn[[3]], 0, kk]], 
                          ",",
                          If[nn[[4]] < 0, ll - 1, If[ll == nn[[4]], 0, ll]]];
                        
                        If[(ii < Abs[nn[[1]]]) || (jj < Abs[nn[[2]]]) || (kk <
                                 Abs[nn[[3]]]) ||
                            \
(ll < Abs[nn[[4]]]), WriteString[mout, ","],];),],
                    {ll, Abs[nn[[4]]]}], {kk, Abs[nn[[3]]]}],
                {jj, Abs[nn[[2]]]}], {ii, Abs[nn[[1]]]}];),];
        WriteString[mout, "};\n"];)];
simpleconcerns[] := Block[{dep, symdep, passtruc, flatps, remps, sortsymb}, (
        dep = Table[functions[[ii, 3]], {ii, fun}];
        If[constants[[1]] === I, constart = 2, constart = 1];
        Do[
          Do[AppendTo[dep[[ii]], D[functions[[ii, 2]], constants[[jj]]]], {jj,
               constart, con}], {ii, fun}];
        symdep = Table[{}, {ii, con + dim - constart + 1}];
        Do[
          Do[If[dep[[jj, ii]] =!= 0, AppendTo[symdep[[ii]], jj],], {jj, 
              Length[dep]}], {ii, Length[symdep]}]; 
        Do[Do[Do[
              If[D[gp[[jj, kk]], coords[[sub[ii]]]] =!= 0, 
                symdep[[ii]] = Union[symdep[[ii]], {0}],],
              {kk, dim}], {jj, dim}], {ii, dim}]; 
        Do[Do[Do[
              If[D[gp[[jj, kk]], constants[[ii]]] =!= 0, 
                AppendTo[symdep[[ii + dim - constart + 1]], 0],],
              {kk, dim}], {jj, dim}], {ii, constart, con}]; 
        symdep = Table[Union[symdep[[ii]]], {ii, Length[symdep]}];(* 
          symdep = Select[Union[symdep], Length[#1] > 1 &]; *)
        
        symdep = Select[Union[symdep], Length[#1] > 0 &]; 
        Do[If[MemberQ[symdep[[ii]], 0], 
            symdep[[ii]] = Rest[symdep[[ii]]],], {ii, Length[symdep]}];
        passtruc = {};
        pp = 0;
        While[Length[symdep] > 0, (
            AppendTo[passtruc, symdep[[1]]];
            symdep = Rest[symdep];
            pp = pp + 1;
            ss = 1;
            While[ss <= Length[symdep],
              If[Length[Intersection[passtruc[[pp]], symdep[[ss]]]] > 0,
                (passtruc[[pp]] = Union[passtruc[[pp]], symdep[[ss]]];
                  symdep = Drop[symdep, {ss}];
                  ss = 1;), ss = ss + 1]];)];
        WriteString[mout, "int number_of_passes = ", Length[passtruc], 
          ";\n"];
        WriteString[mout, "int number_to_simplify;\n"];
        WriteString[mout, "int pass_num_fns[", Length[passtruc], "] = "];
        WriteString[mout, 
          Table[Length[passtruc[[i]]], {i, Length[passtruc]}]];
        WriteString[mout, ";\n"];
        flatps = Flatten[passtruc] - 1;
        WriteString[mout, "int pass_fns[", Length[flatps], "] = ", flatps, 
          ";\n"];
        WriteString[mout, "int pass_fn_index;\n"];
        sortvar = {};
        sortsymb = {};
        WriteString[mout, "int sort_variable[", fun, "] = {"];
        Do[(funlen = Length[functions[[ii, 2]]];
            it = 0;
            this = functions[[ii, 2]];
            
            If[AtomQ[this] && (! NumberQ[this]), (it = this; 
                AppendTo[sortsymb, it]; itn = 1;),];
            
            Do[(If[AtomQ[this[[jj]]] && (! NumberQ[this[[jj]]]), (it = 
                      this[[jj]]; AppendTo[sortsymb, it]; itn = jj; 
                    Break[];),];
                If[(Head[this[[jj]]] === Power),
                  
                  If[(! MemberQ[sortsymb, this[[jj, 1]]]), (it = 
                        this[[jj, 1]]; AppendTo[sortsymb, it]; itn = jj; 
                      Break[];),],];
                If[(Head[this[[jj]]] === Times),
                  
                  If[(Head[this[[jj, 2]]] === Power) && (Head[this[[jj, 1]]] ===
                           Integer),
                    
                    If[(! MemberQ[sortsymb, this[[jj, 2, 1]]]), (it = 
                          this[[jj, 2, 1]]; AppendTo[sortsymb, it]; itn = jj; 
                        Break[];),],
                    
                    If[(Head[this[[jj, 2]]] === 
                            Symbol) && (Head[this[[jj, 1]]] === Integer),
                      
                      If[(! MemberQ[sortsymb, this[[jj, 2]]]), (it = 
                            this[[jj, 2]]; AppendTo[sortsymb, it]; itn = jj; 
                          Break[];),],]],];),
              {jj, funlen}];
            
            If[! NumberQ[it], (WriteString[
                  mout, -1 + Position[var, it][[1, 1]]];
                If[Head[this] === Times, itn = 1,];
                AppendTo[sortvar, itn];
                Do[AppendTo[sortvar, 0], {i, dim}];),];
            If[ii < fun, WriteString[mout, ","],];), {ii, fun}];
        WriteString[mout, "};\n"];
        )];
ints = {};
constants = {};
functions = {};
ansatze = {};
headers[] := Block[{argtest, argexp}, (dim = Length[coords];
        con = Length[constants];
        fun = Length[functions];
        ans = Length[ansatze];
        functions = Expand[functions];
        ptab = {};
        Do[(dummy = FactorInteger[Exponent[functions[[ii, 1]],
                  (#1 /. {aa_^bb_ -> aa, xx_ -> xx}) &[functions[[ii, 1]]]]];
            AppendTo[ptab, Table[dummy[[jj, 1]], {jj, Length[dummy]}]];),
          {ii, Length[functions]}]; ints = Rest[Union[Flatten[FactorInteger[
                  Union[Flatten[{ints, ptab, 2, dim, dim - 1, dim - 2}]]]]]];
        Do[findenom[functions[[ii, 2]]], {ii, fun}];
        Do[findenom[ansatze[[ii, 2]]], {ii, ans}];
        findenom[gp];
        findenom[ginvp];
        findenom[irmdgp];
        num = dim + fun + ans + Length[constants] + Length[ints];
        pout = OpenWrite[ptahdir <> "include/params.h"];
        WriteString[pout, "#define dimension ", dim, "\n"];
        Close[pout];
        pout = OpenAppend[ptahdir <> "include/params.h"];
        WriteString[pout, "#define spinor_dimension ", 2^Floor[dim/2], "\n"];
        WriteString[pout, "#define number_of_variables ",
          dim + fun + ans + con + Length[ints], "\n"];
        WriteString[pout, "#define number_of_functions ", fun, "\n"];
        WriteString[pout, "#define number_of_ansatze ", ans, "\n"];
        WriteString[pout, "#define number_of_constants ", con, "\n"];
        WriteString[pout, "#define number_of_fractions ", Length[ints], 
          "\n"];
        Close[pout];
        var = {};
        Do[AppendTo[var, coords[[sub[ii]]]], {ii, dim}];
        Do[If[AtomQ[functions[[ii, 1]]], AppendTo[var, functions[[ii, 1]]],
            AppendTo[var, functions[[ii, 1, 1]]]], {ii, fun}];
        Do[AppendTo[var, ansatze[[ii, 1]]], {ii, ans}];
        var = Join[var, constants];
        var = Join[var, ints];
        mout = OpenWrite[ptahdir <> "include/metric.h"];
        Close[mout];
        mout = OpenAppend[ptahdir <> "include/metric.h"];
        WriteString[mout, "char variables[", num, "] = {"];
        Do[(WriteString[mout, "'", var[[ii]], "'"];
            If[ii < num, WriteString[mout, ","],];), {ii, num}];
        WriteString[mout, "};\n"];
        WriteString[mout, "int integers[", Length[ints], "] = {"];
        Do[(WriteString[mout, ints[[ii]]];
            If[ii < Length[ints], WriteString[mout, ","],];), {ii, 
            Length[ints]}];
        WriteString[mout, "};\n"];
        WriteString[mout, "bool argument[", dim*(fun + ans), "] = {"];
        Do[(Do[(If[functions[[ii, 3, jj]] =!= 0,
                  WriteString[mout, "true"], WriteString[mout, "false"]];
                
                If[(ii == fun) && (jj == dim), , 
                    WriteString[mout, ","]];), {jj, dim}];
            If[ii < fun, WriteString[mout, "\n                     "],];),
          {ii, fun}];
        If[ans > 0, WriteString[mout, ",\n                     "],];
        Do[(Do[(If[ansatze[[ii, 3, jj]] =!= 0,
                  WriteString[mout, "true"], WriteString[mout, "false"]];
                
                If[(ii == ans) && (jj == dim), , 
                    WriteString[mout, ","]];), {jj, dim}];
            If[ii < ans, WriteString[mout, "\n                     "],];),
          {ii, ans}];
        WriteString[mout, "};\n"];
        WriteString[mout, "int function_power[", fun, "] = {"];
        Do[(WriteString[mout, Exponent[functions[[ii, 1]], var[[ii + dim]]]];
            If[ii < fun, WriteString[mout, ","],];), {ii, fun}];
        WriteString[mout, "};\n"];
        simpleconcerns[];
        WriteString[mout, "term* function_terms[", fun, "] = {"];
        Do[(WriteString[mout, "NULL"];
            If[ii < fun, WriteString[mout, ","],];), {ii, fun}];
        WriteString[mout, "};\n"];
        WriteString[mout, "sum* functions[", fun, "];\n"];
        WriteString[mout, "sum* derivatives[", (fun + ans)*dim, "];\n"];
        WriteString[mout, "int factor_powers_temp[", num, "];\n"];
        WriteString[mout, "int factor_powers_temp_d[", num, "];\n"];
        WriteString[mout, "int factor_powers_temp_s[", num, "];\n"];
        WriteString[mout, "int factor_powers_temp_i[", num, "];\n"]; 
        WriteString[mout, "int factor_powers_dim[", num, "] = {"];
        Do[WriteString[mout, "0,"], {ii, num - Length[ints]}];
        Do[(WriteString[mout, 
              If[Length[ff = Cases[FactorInteger[dim], {ints[[ii]], _}]] > 
                  0, -ff[[1, 2]], 0]];
            If[ii =!= Length[ints], WriteString[mout, ","],];), {ii, 
            Length[ints]}];
        WriteString[mout, "};\n"];
        WriteString[mout, "int factor_powers_dimm2[", num, "] = {"];
        Do[WriteString[mout, "0,"], {ii, num - Length[ints]}];
        Do[(WriteString[mout, 
              If[Length[ff = Cases[FactorInteger[dim - 2], {ints[[ii]], _}]] >
                   0, -ff[[1, 2]], 0]];
            If[ii =!= Length[ints], WriteString[mout, ","],];), {ii, 
            Length[ints]}];
        WriteString[mout, "};\n"];
        WriteString[mout, "int factor_powers_dimdimm1[", num, "] = {"];
        Do[WriteString[mout, "0,"], {ii, num - Length[ints]}];
        Do[(WriteString[mout, 
              If[Length[
                    ff = Cases[
                        FactorInteger[dim*(dim - 1)], {ints[[ii]], _}]] > 
                  0, -ff[[1, 2]], 0]];
            If[ii =!= Length[ints], WriteString[mout, ","],];), {ii, 
            Length[ints]}];
        WriteString[mout, "};\n"];
        WriteString[mout, "int gcd_factor_powers[", num, "];\n"];
        WriteString[mout, "int pwr[", num, "];\n"];
        fntab = Flatten[{Table[Rest[functions[[ii]]], {ii, fun}],
              Table[Rest[ansatze[[ii]]], {ii, ans}]}];
        Do[AppendTo[sortvar, 0], {ii, ans*(dim + 1)}];
        exprout[fntab, "f"];
        sortvar = Table[0, {ii, dim*dim}];
        Print["functions completed..."];
        indout[gp, "g", {dim, dim}];
        tg = {};
        Do[
          Do[If[gp[[ii, jj]] =!= 0, AppendTo[tg, Expand[gp[[ii, jj]]]],], {jj,
               dim}], {ii, dim}];
        exprout[tg, "g"];
        Print["g completed..."];
        indout[ginvp, "gi", {dim, dim}];
        tg = {};
        Do[
          Do[If[ginvp[[ii, jj]] =!= 0, 
              AppendTo[tg, Expand[ginvp[[ii, jj]]]],], {jj, dim}],
          {ii, dim}];
        exprout[tg, "gi"];
        Print["gi completed..."];
        tg = {Expand[irmdgp]};
        exprout[tg, "d"];
        Close[mout];
        Print["d completed..."];)];
gammaout[xx_List, nam_] := Block[{tg, rank, dtab}, (
        rank = TensorRank[xx];
        dim = Length[coords];
        con = Length[constants];
        fun = Length[functions];
        ans = Length[ansatze];
        var = {};
        Do[AppendTo[var, coords[[sub[ii]]]], {ii, dim}];
          Do[If[AtomQ[functions[[ii, 1]]], AppendTo[var, functions[[ii, 1]]],
                AppendTo[var, functions[[ii, 1, 1]]]], {ii, fun}];
          Do[AppendTo[var, ansatze[[ii, 1]]], {ii, ans}];
          var = Join[var, constants];
          var = Join[var, ints];
        mout = OpenWrite[ptahdir <> "gammas/gammas.h"];
        WriteString[mout, "#define dimension ", dim, "\n"];
        WriteString[mout, "#define spinor_dimension ", 2^Floor[dim/2], "\n"];
        sortvar = Table[0, {ii, dim*dim}];
        If[rank == 1, dtab = {Length[xx]},
          If[rank == 2, dtab = {Length[xx], Length[xx[[1]]]},
            
            If[rank == 3, 
              dtab = {Length[xx], Length[xx[[1]]], Length[xx[[1, 1]]]},]]];
        Do[If[dtab[[i]] == (dim + 1), dtab[[i]] = dim,], {i, Length[dtab]}];
        Do[If[dtab[[i]] != dim, dtab[[i]] = -dtab[[i]],], {i, Length[dtab]}];
        indout[xx, nam, dtab];
        Do[dtab[[i]] = Abs[dtab[[i]]], {i, Length[dtab]}];
        tg = {};
        If[rank == 1, Do[If[xx[[ii]] =!= 0,
              AppendTo[tg, Expand[xx[[ii]]]],], {ii, dtab[[1]]}],];
        If[rank == 2, Do[Do[If[xx[[ii, jj]] =!= 0,
                AppendTo[tg, Expand[xx[[ii, jj]]]],], {jj, dtab[[2]]}], {ii, 
              dtab[[1]]}],];
        If[rank == 3, Do[Do[Do[If[xx[[ii, jj, kk]] =!= 0,
                  AppendTo[tg, Expand[xx[[ii, jj, kk]]]],], {kk, 
                  dtab[[3]]}], {jj, dtab[[2]]}], {ii, dtab[[1]]}],];
        exprout[tg, nam];
        Close[mout];
        Print[nam, " completed..."];)];
tensor[xx_List, nam_] := Block[{tg, rank, dtab}, (
        rank = TensorRank[xx];
        mout = OpenAppend[ptahdir <> "include/metric.h"];
        sortvar = Table[0, {ii, dim*dim}];
        If[rank == 1, dtab = {Length[xx]},
          If[rank == 2, dtab = {Length[xx], Length[xx[[1]]]},
            
            If[rank == 3, 
              dtab = {Length[xx], Length[xx[[1]]], Length[xx[[1, 1]]]},
              If[rank == 4, dtab = {Length[xx], Length[xx[[1]]],
                    Length[xx[[1, 1]]], Length[xx[[1, 1, 1]]]},]]]];
        Do[If[dtab[[i]] != dim, dtab[[i]] = -dtab[[i]],], {i, Length[dtab]}];
        indout[xx, nam, dtab];
        Do[dtab[[i]] = Abs[dtab[[i]]], {i, Length[dtab]}];
        tg = {};
        If[rank == 1, Do[If[xx[[ii]] =!= 0,
              AppendTo[tg, Expand[xx[[ii]]]],], {ii, dtab[[1]]}],];
        If[rank == 2, Do[Do[If[xx[[ii, jj]] =!= 0,
                AppendTo[tg, Expand[xx[[ii, jj]]]],], {jj, dtab[[2]]}], {ii, 
              dtab[[1]]}],];
        If[rank == 3, Do[Do[Do[If[xx[[ii, jj, kk]] =!= 0,
                  AppendTo[tg, Expand[xx[[ii, jj, kk]]]],], {kk, 
                  dtab[[3]]}], {jj, dtab[[2]]}], {ii, dtab[[1]]}],];
        If[rank == 4, Do[Do[Do[Do[If[xx[[ii, jj, kk, ll]] =!= 0,
                    AppendTo[tg, Expand[xx[[ii, jj, kk, ll]]]],],
                  {ll, dtab[[4]]}], {kk, dtab[[3]]}], {jj, dtab[[2]]}], {ii, 
              dtab[[1]]}],];
        exprout[tg, nam];
        Close[mout];
        Print[nam, " completed..."];)];