//
// PTAH - Parallel Tensor Analysis Hybrid   Copyright (C) 2002 Kenneth R. Koehler 
//
// e-mail address - kenneth.koehler@uc.edu
//
// This program is free software; you can redistribute it and/or modify it under the terms of the
// GNU General Public License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
// without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
// PURPOSE. See the GNU General Public License for more details. 
//
// You should have received a copy of the GNU General Public License along with this program; if
// not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// component.cc

#include <ptah.h>
#include <element.h>
#include <hash.h>
#include <ntuple.h>


extern component::component(hash* ntuple_param, int* indices_param) {
#ifdef tracentry
    trace_co += 1;
#endif
#ifdef debug
    component_magic_no = component_magic;
    for (int i = 0; i < ntuple_param->rank; i++) {
      if (indices_param[i] < 0)
	die("negative index for new component");
      if (((ntuple *) ntuple_param)->spinor[i]) {
	if (indices_param[i] >= spinor_dimension)
	  die("spinor index out of bounds for new component");}
      else {
	if (indices_param[i] >= dimension)
	  die("index out of bounds for new component");}}
    if (((ntuple *) ntuple_param)->sub(indices_param) != NULL)
      die("attempting to create a duplicate component");
#endif
    indices = 0;
    for (int i = 0; i < ntuple_param->rank; i++)
      indices |= (((long long) indices_param[i]) & 63) << (6 * i);
    ntuple_param->number_of_components += 1;
    value = new sum;
    if (((ntuple *) ntuple_param)->rank <= 6)
      ((ntuple *) ntuple_param)->comparray[((ntuple *) ntuple_param)->ca_index(indices_param)] = this;
    if (value == NULL)
      die("allocating value (sum)"); }

extern component::component(hash* ntuple_param, int* indices_param, sum* new_sum) {
#ifdef tracentry
    trace_co2 += 1;
#endif
#ifdef debug
    component_magic_no = component_magic;
    for (int i = 0; i < ntuple_param->rank; i++) {
      if (indices_param[i] < 0)
	die("negative index for new component (2)");
      if (((ntuple *) ntuple_param)->spinor[i]) {
	if (indices_param[i] >= spinor_dimension)
	  die("spinor index out of bounds for new component (2)");}
      else {
	if (indices_param[i] >= dimension)
	  die("index out of bounds for new component (2)");}}
    if (((ntuple *) ntuple_param)->sub(indices_param) != NULL)
      die("attempting to create a duplicate component");
#endif
    indices = 0;
    for (int i = 0; i < ntuple_param->rank; i++)
      indices |= (((long long) indices_param[i]) & 63) << (6 * i);
    ntuple_param->number_of_components += 1;
    if (((ntuple *) ntuple_param)->rank <= 6)
	((ntuple *) ntuple_param)->comparray[((ntuple *) ntuple_param)->ca_index(indices_param)] = this;
    value = new_sum; }
