(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     14923,        384]*)
(*NotebookOutlinePosition[     15910,        416]*)
(*  CellTagsIndexPosition[     15866,        412]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(\(Clear["\<Global`*\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Run["\<ls -Q /home/ptahusr/*ptah.out > /tmp/ptah.out.ls\>"];\)\)], \
"Input"],

Cell[BoxData[
    \(\(nametab\  = \ 
        Flatten[Import["\</tmp/ptah.out.ls\>", \ "\<Table\>"]];\)\)], "Input"],

Cell[BoxData[{
    \(\(gp\  = Table[Table[0, {i, 10}], {j, 10}]\ ;\)\), "\n", 
    \(\(ginv\  = \ 
        Table[Table[0, {i, 10}], {j, 10}];\)\), "\[IndentingNewLine]", 
    \(\(ast1\  = \ 
        Table[Table[0, {i, 10}], {j, 10}];\)\), "\[IndentingNewLine]", 
    \(\(ast2\  = \ 
        Table[Table[0, {i, 10}], {j, 10}];\)\), "\[IndentingNewLine]", 
    \(\(ast3\  = \ 
        Table[Table[0, {i, 10}], {j, 10}];\)\), "\[IndentingNewLine]", 
    \(\(ast4\  = \ 
        Table[Table[0, {i, 10}], {j, 10}];\)\), "\[IndentingNewLine]", 
    \(\(ast5\  = \ 
        Table[Table[0, {i, 10}], {j, 10}];\)\), "\[IndentingNewLine]", 
    \(\(isrdmg\  = \ 0;\)\), "\[IndentingNewLine]", 
    \(\(dests\  = \ 0;\)\), "\[IndentingNewLine]", 
    \(\(test\  = \ 0;\)\)}], "Input"],

Cell["do this one if everything ran in one run", "Text"],

Cell[BoxData[
    \(\(Do[Get[nametab[\([ii]\)]], {ii, Length[nametab]}];\)\)], "Input"],

Cell["do this one if results from multiple runs were collected", "Text"],

Cell[BoxData[
    \(<< /home/ptahusr/collected.out\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(TableForm[gp]\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
          {"0", "1", "0", "0", "0", "0", "0", "0", "0", "0"},
          {"0", "0", "1", "0", "0", "0", "0", "0", "0", "0"},
          {"0", "0", "0", "1", "0", "0", "0", "0", "0", "0"},
          {"0", "0", "0", "0", "1", "0", "0", "0", "0", "0"},
          {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0"},
          {"0", "0", "0", "0", "0", "0", "1", "0", "0", "0"},
          {"0", "0", "0", "0", "0", "0", "0", "1", "0", "0"},
          {"0", "0", "0", "0", "0", "0", "0", "0", "1", "0"},
          {"0", "0", "0", "0", "0", "0", "0", "0", "0", "1"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TableForm[ginv]\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
          {"0", "1", "0", "0", "0", "0", "0", "0", "0", "0"},
          {"0", "0", "1", "0", "0", "0", "0", "0", "0", "0"},
          {"0", "0", "0", "1", "0", "0", "0", "0", "0", "0"},
          {"0", "0", "0", "0", "1", "0", "0", "0", "0", "0"},
          {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0"},
          {"0", "0", "0", "0", "0", "0", "1", "0", "0", "0"},
          {"0", "0", "0", "0", "0", "0", "0", "1", "0", "0"},
          {"0", "0", "0", "0", "0", "0", "0", "0", "1", "0"},
          {"0", "0", "0", "0", "0", "0", "0", "0", "0", "1"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(isrdmg\)], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TableForm[ast1]\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {
            "0", \(a - b\), \(a - c\), \(a - d\), \(a - e\), \(a - f\), \(a - 
              g\), \(a - h\), \(a - i\), \(a - j\)},
          {\(\(-a\) + b\), 
            "0", \(b - c\), \(b - d\), \(b - e\), \(b - f\), \(b - g\), \(b - 
              h\), \(b - i\), \(b - j\)},
          {\(\(-a\) + c\), \(\(-b\) + c\), 
            "0", \(c - d\), \(c - e\), \(c - f\), \(c - g\), \(c - h\), \(c - 
              i\), \(c - j\)},
          {\(\(-a\) + d\), \(\(-b\) + d\), \(\(-c\) + d\), 
            "0", \(d - e\), \(d - f\), \(d - g\), \(d - h\), \(d - i\), \(d - 
              j\)},
          {\(\(-a\) + e\), \(\(-b\) + e\), \(\(-c\) + e\), \(\(-d\) + e\), 
            "0", \(e - f\), \(e - g\), \(e - h\), \(e - i\), \(e - j\)},
          {\(\(-a\) + f\), \(\(-b\) + f\), \(\(-c\) + f\), \(\(-d\) + 
              f\), \(\(-e\) + f\), 
            "0", \(f - g\), \(f - h\), \(f - i\), \(f - j\)},
          {\(\(-a\) + g\), \(\(-b\) + g\), \(\(-c\) + g\), \(\(-d\) + 
              g\), \(\(-e\) + g\), \(\(-f\) + g\), 
            "0", \(g - h\), \(g - i\), \(g - j\)},
          {\(\(-a\) + h\), \(\(-b\) + h\), \(\(-c\) + h\), \(\(-d\) + 
              h\), \(\(-e\) + h\), \(\(-f\) + h\), \(\(-g\) + h\), 
            "0", \(h - i\), \(h - j\)},
          {\(\(-a\) + i\), \(\(-b\) + i\), \(\(-c\) + i\), \(\(-d\) + 
              i\), \(\(-e\) + i\), \(\(-f\) + i\), \(\(-g\) + i\), \(\(-h\) + 
              i\), "0", \(i - j\)},
          {\(\(-a\) + j\), \(\(-b\) + j\), \(\(-c\) + j\), \(\(-d\) + 
              j\), \(\(-e\) + j\), \(\(-f\) + j\), \(\(-g\) + j\), \(\(-h\) + 
              j\), \(\(-i\) + j\), "0"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TableForm[ast2]\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {
            "0", \(k - l\), \(k - m\), \(k - n\), \(k - o\), \(k - p\), \(k - 
              q\), \(k - r\), \(k - s\), \(k - t\)},
          {\(\(-k\) + l\), 
            "0", \(l - m\), \(l - n\), \(l - o\), \(l - p\), \(l - q\), \(l - 
              r\), \(l - s\), \(l - t\)},
          {\(\(-k\) + m\), \(\(-l\) + m\), 
            "0", \(m - n\), \(m - o\), \(m - p\), \(m - q\), \(m - r\), \(m - 
              s\), \(m - t\)},
          {\(\(-k\) + n\), \(\(-l\) + n\), \(\(-m\) + n\), 
            "0", \(n - o\), \(n - p\), \(n - q\), \(n - r\), \(n - s\), \(n - 
              t\)},
          {\(\(-k\) + o\), \(\(-l\) + o\), \(\(-m\) + o\), \(\(-n\) + o\), 
            "0", \(o - p\), \(o - q\), \(o - r\), \(o - s\), \(o - t\)},
          {\(\(-k\) + p\), \(\(-l\) + p\), \(\(-m\) + p\), \(\(-n\) + 
              p\), \(\(-o\) + p\), 
            "0", \(p - q\), \(p - r\), \(p - s\), \(p - t\)},
          {\(\(-k\) + q\), \(\(-l\) + q\), \(\(-m\) + q\), \(\(-n\) + 
              q\), \(\(-o\) + q\), \(\(-p\) + q\), 
            "0", \(q - r\), \(q - s\), \(q - t\)},
          {\(\(-k\) + r\), \(\(-l\) + r\), \(\(-m\) + r\), \(\(-n\) + 
              r\), \(\(-o\) + r\), \(\(-p\) + r\), \(\(-q\) + r\), 
            "0", \(r - s\), \(r - t\)},
          {\(\(-k\) + s\), \(\(-l\) + s\), \(\(-m\) + s\), \(\(-n\) + 
              s\), \(\(-o\) + s\), \(\(-p\) + s\), \(\(-q\) + s\), \(\(-r\) + 
              s\), "0", \(s - t\)},
          {\(\(-k\) + t\), \(\(-l\) + t\), \(\(-m\) + t\), \(\(-n\) + 
              t\), \(\(-o\) + t\), \(\(-p\) + t\), \(\(-q\) + t\), \(\(-r\) + 
              t\), \(\(-s\) + t\), "0"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TableForm[ast3]\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {
            "0", \(u - v\), \(u - w\), \(u - x\), \(u - y\), \(u - 
              z\), \(\(-A\) + u\), \(\(-B\) + u\), \(\(-C\) + u\), \(\(-D\) + 
              u\)},
          {\(\(-u\) + v\), 
            "0", \(v - w\), \(v - x\), \(v - y\), \(v - z\), \(\(-A\) + 
              v\), \(\(-B\) + v\), \(\(-C\) + v\), \(\(-D\) + v\)},
          {\(\(-u\) + w\), \(\(-v\) + w\), 
            "0", \(w - x\), \(w - y\), \(w - z\), \(\(-A\) + w\), \(\(-B\) + 
              w\), \(\(-C\) + w\), \(\(-D\) + w\)},
          {\(\(-u\) + x\), \(\(-v\) + x\), \(\(-w\) + x\), 
            "0", \(x - y\), \(x - z\), \(\(-A\) + x\), \(\(-B\) + 
              x\), \(\(-C\) + x\), \(\(-D\) + x\)},
          {\(\(-u\) + y\), \(\(-v\) + y\), \(\(-w\) + y\), \(\(-x\) + y\), 
            "0", \(y - z\), \(\(-A\) + y\), \(\(-B\) + y\), \(\(-C\) + 
              y\), \(\(-D\) + y\)},
          {\(\(-u\) + z\), \(\(-v\) + z\), \(\(-w\) + z\), \(\(-x\) + 
              z\), \(\(-y\) + z\), 
            "0", \(\(-A\) + z\), \(\(-B\) + z\), \(\(-C\) + z\), \(\(-D\) + 
              z\)},
          {\(A - u\), \(A - v\), \(A - w\), \(A - x\), \(A - y\), \(A - z\), 
            "0", \(A - B\), \(A - C\), \(A - D\)},
          {\(B - u\), \(B - v\), \(B - w\), \(B - x\), \(B - y\), \(B - 
              z\), \(\(-A\) + B\), "0", \(B - C\), \(B - D\)},
          {\(C - u\), \(C - v\), \(C - w\), \(C - x\), \(C - y\), \(C - 
              z\), \(\(-A\) + C\), \(\(-B\) + C\), "0", \(C - D\)},
          {\(D - u\), \(D - v\), \(D - w\), \(D - x\), \(D - y\), \(D - 
              z\), \(\(-A\) + D\), \(\(-B\) + D\), \(\(-C\) + D\), "0"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TableForm[ast4]\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {
            "0", \(F - G\), \(F - H\), \(F - J\), \(F - K\), \(F - L\), \(F - 
              M\), \(F - N\), \(F - O\), \(F - P\)},
          {\(\(-F\) + G\), 
            "0", \(G - H\), \(G - J\), \(G - K\), \(G - L\), \(G - M\), \(G - 
              N\), \(G - O\), \(G - P\)},
          {\(\(-F\) + H\), \(\(-G\) + H\), 
            "0", \(H - J\), \(H - K\), \(H - L\), \(H - M\), \(H - N\), \(H - 
              O\), \(H - P\)},
          {\(\(-F\) + J\), \(\(-G\) + J\), \(\(-H\) + J\), 
            "0", \(J - K\), \(J - L\), \(J - M\), \(J - N\), \(J - O\), \(J - 
              P\)},
          {\(\(-F\) + K\), \(\(-G\) + K\), \(\(-H\) + K\), \(\(-J\) + K\), 
            "0", \(K - L\), \(K - M\), \(K - N\), \(K - O\), \(K - P\)},
          {\(\(-F\) + L\), \(\(-G\) + L\), \(\(-H\) + L\), \(\(-J\) + 
              L\), \(\(-K\) + L\), 
            "0", \(L - M\), \(L - N\), \(L - O\), \(L - P\)},
          {\(\(-F\) + M\), \(\(-G\) + M\), \(\(-H\) + M\), \(\(-J\) + 
              M\), \(\(-K\) + M\), \(\(-L\) + M\), 
            "0", \(M - N\), \(M - O\), \(M - P\)},
          {\(\(-F\) + N\), \(\(-G\) + N\), \(\(-H\) + N\), \(\(-J\) + 
              N\), \(\(-K\) + N\), \(\(-L\) + N\), \(\(-M\) + N\), 
            "0", \(N - O\), \(N - P\)},
          {\(\(-F\) + O\), \(\(-G\) + O\), \(\(-H\) + O\), \(\(-J\) + 
              O\), \(\(-K\) + O\), \(\(-L\) + O\), \(\(-M\) + O\), \(\(-N\) + 
              O\), "0", \(O - P\)},
          {\(\(-F\) + P\), \(\(-G\) + P\), \(\(-H\) + P\), \(\(-J\) + 
              P\), \(\(-K\) + P\), \(\(-L\) + P\), \(\(-M\) + P\), \(\(-N\) + 
              P\), \(\(-O\) + P\), "0"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TableForm[ast5]\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {
            "0", \(Q - R\), \(Q - S\), \(Q - T\), \(Q - U\), \(Q - V\), \(Q - 
              W\), \(Q - X\), \(Q - Y\), \(Q - Z\)},
          {\(\(-Q\) + R\), 
            "0", \(R - S\), \(R - T\), \(R - U\), \(R - V\), \(R - W\), \(R - 
              X\), \(R - Y\), \(R - Z\)},
          {\(\(-Q\) + S\), \(\(-R\) + S\), 
            "0", \(S - T\), \(S - U\), \(S - V\), \(S - W\), \(S - X\), \(S - 
              Y\), \(S - Z\)},
          {\(\(-Q\) + T\), \(\(-R\) + T\), \(\(-S\) + T\), 
            "0", \(T - U\), \(T - V\), \(T - W\), \(T - X\), \(T - Y\), \(T - 
              Z\)},
          {\(\(-Q\) + U\), \(\(-R\) + U\), \(\(-S\) + U\), \(\(-T\) + U\), 
            "0", \(U - V\), \(U - W\), \(U - X\), \(U - Y\), \(U - Z\)},
          {\(\(-Q\) + V\), \(\(-R\) + V\), \(\(-S\) + V\), \(\(-T\) + 
              V\), \(\(-U\) + V\), 
            "0", \(V - W\), \(V - X\), \(V - Y\), \(V - Z\)},
          {\(\(-Q\) + W\), \(\(-R\) + W\), \(\(-S\) + W\), \(\(-T\) + 
              W\), \(\(-U\) + W\), \(\(-V\) + W\), 
            "0", \(W - X\), \(W - Y\), \(W - Z\)},
          {\(\(-Q\) + X\), \(\(-R\) + X\), \(\(-S\) + X\), \(\(-T\) + 
              X\), \(\(-U\) + X\), \(\(-V\) + X\), \(\(-W\) + X\), 
            "0", \(X - Y\), \(X - Z\)},
          {\(\(-Q\) + Y\), \(\(-R\) + Y\), \(\(-S\) + Y\), \(\(-T\) + 
              Y\), \(\(-U\) + Y\), \(\(-V\) + Y\), \(\(-W\) + Y\), \(\(-X\) + 
              Y\), "0", \(Y - Z\)},
          {\(\(-Q\) + Z\), \(\(-R\) + Z\), \(\(-S\) + Z\), \(\(-T\) + 
              Z\), \(\(-U\) + Z\), \(\(-V\) + Z\), \(\(-W\) + Z\), \(\(-X\) + 
              Z\), \(\(-Y\) + Z\), "0"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(test\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dests\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 800}, {0, 600}},
CellGrouping->Manual,
WindowSize->{734, 504},
WindowMargins->{{Automatic, 2}, {Automatic, 0}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperSize"->{612, 792},
"PaperOrientation"->"Portrait",
"PostScriptOutputFile":>FrontEnd`FileName[{$RootDirectory, "home", "ken", \
"projects", "ptah", "mathematica"}, "dbraneval.nb.ps", CharacterEncoding -> \
"ISO8859-1"],
"Magnification"->1},
ShowCellLabel->False
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 59, 1, 27, "Input"],
Cell[1779, 52, 99, 2, 27, "Input"],
Cell[1881, 56, 115, 2, 27, "Input"],
Cell[1999, 60, 773, 16, 171, "Input"],
Cell[2775, 78, 56, 0, 32, "Text"],
Cell[2834, 80, 87, 1, 27, "Input"],
Cell[2924, 83, 72, 0, 32, "Text"],
Cell[2999, 85, 63, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[3087, 90, 46, 1, 27, "Input"],
Cell[3136, 93, 821, 17, 189, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3994, 115, 48, 1, 27, "Input"],
Cell[4045, 118, 821, 17, 189, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4903, 140, 39, 1, 27, "Input"],
Cell[4945, 143, 35, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5017, 149, 48, 1, 27, "Input"],
Cell[5068, 152, 1855, 36, 189, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6960, 193, 48, 1, 27, "Input"],
Cell[7011, 196, 1855, 36, 189, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8903, 237, 48, 1, 27, "Input"],
Cell[8954, 240, 1842, 35, 189, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10833, 280, 48, 1, 27, "Input"],
Cell[10884, 283, 1855, 36, 189, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12776, 324, 48, 1, 27, "Input"],
Cell[12827, 327, 1855, 36, 189, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14719, 368, 37, 1, 27, "Input"],
Cell[14759, 371, 35, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14831, 377, 38, 1, 27, "Input"],
Cell[14872, 380, 35, 1, 27, "Output"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

